unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Label6: TLabel;
    Label7: TLabel;
    Button5: TButton;
    Image1: TImage;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  function is_one(x1: Real; x2: Real): Boolean;
  function distance(x1: Real; y1: Real; x2: Real; y2: Real): Real;
  function calc_v(x1: Real; y1: Real; z1: Real; x2: Real; y2: Real; z2: Real; x3: Real; y3: Real; z3: Real): Real;
  procedure set_s(v1: Integer; v2: Integer);
  procedure diset_s(v1: Integer; v2: Integer);
  function is_set(v1: Integer; v2: Integer): Boolean;
  procedure cr_st_one();
  procedure cr_st_two();
  procedure visual();


type
 xyz = record
  x: Real;
  y: Real;
  z: Real;
 end;
 xyr = record
  x: Real;
  y: Real;
 end;
 xyg = record
  x: Integer;
  y: Integer;
 end;
 ap = record
  xr: Real;
  yr: Real;
  z: Real;
  xm: Integer;
  ym: Integer;
 end;
 matrix = array [0..2] of array [0..2] of Real;
var
  Form1: TForm1;
  nul_p: array[1..12] of xyr;
  npg: array[1..12] of xyg;
  lt: array[1..24] of xyg;
  trn: array[1..3] of xyz;
  ver: array[1..21] of ap;
  sq1: array[1..8] of ap;
  sq2: array[1..8] of ap;
  sq3: array[1..8] of ap;
  sq4: array[1..8] of ap;
  pl: array[1..21] of array[1..21] of Integer;
  x_bias,y_bias: Real;
  dist: Real;
  l_prj: Real;
  m_now,m_prj,m_wor: matrix;
  i,j,k,l,m: Integer;
  vt,VP,VO: Real;



implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
var
 npi: Integer; //   
begin
 VO:=0;
 VP:=0;
 for i:=1 to 21 do for j:=1 to 21 do diset_s(i,j);
 for i:=1 to 21 do ver[i].z:=-10000;
 Form1.Memo1.Text:='';
 //    
 x_bias:=StrToFloat(Form1.Edit1.Text);
 y_bias:=StrToFloat(Form1.Edit2.Text);
 dist:=StrToFloat(Form1.Edit3.Text);
 l_prj:=StrToFloat(Form1.Edit4.Text);
 m_now[0,0]:=StrToFloat(Form1.Edit5.Text);
 m_now[1,0]:=StrToFloat(Form1.Edit6.Text);
 m_now[2,0]:=StrToFloat(Form1.Edit7.Text);
 m_now[0,1]:=StrToFloat(Form1.Edit8.Text);
 m_now[1,1]:=StrToFloat(Form1.Edit9.Text);
 m_now[2,1]:=StrToFloat(Form1.Edit10.Text);
 m_now[0,2]:=StrToFloat(Form1.Edit11.Text);
 m_now[1,2]:=StrToFloat(Form1.Edit12.Text);
 m_now[2,2]:=StrToFloat(Form1.Edit13.Text);

 //  
 m_prj[0,2]:=l_prj;
 m_prj[1,2]:=l_prj+(y_bias*dist);
 m_prj[2,2]:=m_prj[1,2]+(y_bias*dist);
 m_prj[0,1]:=l_prj+(x_bias*dist);
 m_prj[0,0]:=m_prj[0,1]+(x_bias*dist);
 m_prj[1,0]:=m_prj[0,0]+(y_bias*dist);
 m_prj[2,0]:=m_prj[1,0]+(y_bias*dist);
 m_prj[1,1]:=m_prj[0,1]+(y_bias*dist);
 m_prj[2,1]:=m_prj[1,1]+(y_bias*dist);

 //
 Form1.Memo1.Lines.Add('  ...');
 Form1.Memo1.Lines.Add(FloatToStr(m_prj[0,0])+'       '+FloatToStr(m_prj[1,0])+'       '+FloatToStr(m_prj[2,0]));
 Form1.Memo1.Lines.Add(FloatToStr(m_prj[0,1])+'       '+FloatToStr(m_prj[1,1])+'       '+FloatToStr(m_prj[2,1]));
 Form1.Memo1.Lines.Add(FloatToStr(m_prj[0,2])+'       '+FloatToStr(m_prj[1,2])+'       '+FloatToStr(m_prj[2,2]));

 //  
 for i:=0 to 2 do
  for j:=0 to 2 do
   m_wor[i,j]:=Round((m_prj[i,j]-m_now[i,j])*1000)/1000;

 //
 Form1.Memo1.Lines.Add('');
 Form1.Memo1.Lines.Add('  ...');
 Form1.Memo1.Lines.Add(FloatToStr(m_wor[0,0])+'       '+FloatToStr(m_wor[1,0])+'       '+FloatToStr(m_wor[2,0]));
 Form1.Memo1.Lines.Add(FloatToStr(m_wor[0,1])+'       '+FloatToStr(m_wor[1,1])+'       '+FloatToStr(m_wor[2,1]));
 Form1.Memo1.Lines.Add(FloatToStr(m_wor[0,2])+'       '+FloatToStr(m_wor[1,2])+'       '+FloatToStr(m_wor[2,2]));

 //   
 for i:=1 to 12 do
 begin
  nul_p[i].x:=-10000;
  nul_p[i].y:=-10000;
 end;

 npi:=0;
 for j:=0 to 2 do
 begin
  for i:=0 to 1 do
  begin
   npi:=npi+1;
   if is_one(m_wor[i,j],m_wor[i+1,j])=False then
   begin
    nul_p[npi].x:=Round((m_wor[i,j]/(m_wor[i,j]-m_wor[i+1,j]))*dist*1000)/1000;
    if (i=1) then nul_p[npi].x:=nul_p[npi].x+dist;
    nul_p[npi].y:=dist*j;
   end;
  end;
 end;
 npi:=6;
 for i:=0 to 2 do
 begin
  for j:=0 to 1 do
  begin
   npi:=npi+1;
   if is_one(m_wor[i,j],m_wor[i,j+1])=False then
   begin
    nul_p[npi].y:=Round((m_wor[i,j]/(m_wor[i,j]-m_wor[i,j+1]))*dist*1000)/1000;
    if (j=1) then nul_p[npi].y:=nul_p[npi].y+dist;
    nul_p[npi].x:=dist*i;
   end;
  end;
 end;

 l:=0;
 Form1.Memo1.Lines.Add('');
 Form1.Memo1.Lines.Add('   :');
 for i:=1 to npi do
 begin
  if (nul_p[i].x<>-10000) then
  begin
   l:=l+1;
   Form1.Memo1.Lines.Add('X: '+FloatToStr(nul_p[i].y)+'  Y:'+FloatToStr(nul_p[i].x));
  end;
 end;

 // 
 trn[1].x:=nul_p[3].x;
 trn[1].y:=nul_p[3].y;
 trn[1].z:=0;
 trn[2].x:=nul_p[9].x;
 trn[2].y:=nul_p[9].y;
 trn[2].z:=0;
 trn[3].x:=20;
 trn[3].y:=20;
 trn[3].z:=m_wor[1,1];
 //ShowMessage(FloatToStr(trn[2].y));
 //ShowMessage(FloatToStr(calc_v(trn[1].x,trn[1].y,trn[1].z,trn[2].x,trn[2].y,trn[2].z,trn[3].x,trn[3].y,trn[3].z)));

 for i:=1 to 12 do
 begin
  npg[i].x:=Round(nul_p[i].x*250/dist)+50;
  npg[i].y:=Round(nul_p[i].y*250/dist)+50;
 end;

 cr_st_one();
 cr_st_two();

 if (ver[6].z=0)and(ver[2].z=0)and(ver[7].z<>0)and(ver[10].z<>0) then
  begin set_s(6,11);set_s(2,11); end;
 if (ver[2].z=0)and(ver[7].z=0)and(ver[6].z<>0)and(ver[10].z<>0) then
  begin set_s(9,2);set_s(9,7); end;
 if (ver[7].z=0)and(ver[10].z=0)and(ver[6].z<>0)and(ver[2].z<>0) then
  begin set_s(1,10);set_s(1,7); end;
 if (ver[6].z=0)and(ver[10].z=0)and(ver[2].z<>0)and(ver[7].z<>0) then
  begin set_s(6,3);set_s(10,3); end;
 if (ver[6].z=0)and(ver[7].z=0)and(ver[2].z<>0)and(ver[10].z<>0) then
  begin set_s(1,7);set_s(6,11); end;
 if (ver[2].z=0)and(ver[10].z=0)and(ver[6].z<>0)and(ver[7].z<>0) then
  begin set_s(1,10);set_s(2,11); end;

 if (ver[2].z=0)and(ver[7].z=0)and(ver[6].z=0)and(ver[10].z<>0) then
  set_s(6,11);
 if (ver[2].z=0)and(ver[6].z=0)and(ver[10].z=0)and(ver[7].z<>0) then
  set_s(2,11);
 if (ver[6].z=0)and(ver[7].z=0)and(ver[10].z=0)and(ver[2].z<>0) then
  set_s(1,7);
 if (ver[2].z=0)and(ver[7].z=0)and(ver[10].z=0)and(ver[6].z<>0) then
  set_s(1,10);

 if (ver[2].z=0)and(ver[7].z=0)and(ver[10].z=0)and(ver[6].z=0) then
  set_s(6,7);


 if (ver[7].z=0)and(ver[4].z=0)and(ver[12].z<>0)and(ver[8].z<>0) then
  begin set_s(13,7);set_s(13,4); end;
 if (ver[4].z=0)and(ver[8].z=0)and(ver[7].z<>0)and(ver[12].z<>0) then
  begin set_s(11,4);set_s(11,8); end;
 if (ver[12].z=0)and(ver[8].z=0)and(ver[7].z<>0)and(ver[4].z<>0) then
  begin set_s(3,12);set_s(3,8); end;
 if (ver[7].z=0)and(ver[12].z=0)and(ver[4].z<>0)and(ver[8].z<>0) then
  begin set_s(7,5);set_s(12,5); end;
 if (ver[7].z=0)and(ver[8].z=0)and(ver[4].z<>0)and(ver[12].z<>0) then
  begin set_s(3,8);set_s(7,13); end;
 if (ver[4].z=0)and(ver[12].z=0)and(ver[7].z<>0)and(ver[8].z<>0) then
  begin set_s(3,12);set_s(4,13); end;

 if (ver[7].z=0)and(ver[4].z=0)and(ver[8].z=0)and(ver[12].z<>0) then
  set_s(7,13);
 if (ver[4].z=0)and(ver[7].z=0)and(ver[12].z=0)and(ver[8].z<>0) then
  set_s(4,13);
 if (ver[7].z=0)and(ver[12].z=0)and(ver[8].z=0)and(ver[4].z<>0) then
  set_s(3,8);
 if (ver[4].z=0)and(ver[8].z=0)and(ver[12].z=0)and(ver[7].z<>0) then
  set_s(3,12);

 if (ver[7].z=0)and(ver[4].z=0)and(ver[8].z=0)and(ver[12].z=0) then
  set_s(7,8);


 if (ver[14].z=0)and(ver[10].z=0)and(ver[18].z<>0)and(ver[15].z<>0) then
  begin set_s(14,19);set_s(10,19); end;
 if (ver[10].z=0)and(ver[15].z=0)and(ver[14].z<>0)and(ver[18].z<>0) then
  begin set_s(17,10);set_s(17,15); end;
 if (ver[18].z=0)and(ver[15].z=0)and(ver[14].z<>0)and(ver[10].z<>0) then
  begin set_s(9,18);set_s(9,15); end;
 if (ver[14].z=0)and(ver[18].z=0)and(ver[10].z<>0)and(ver[15].z<>0) then
  begin set_s(11,14);set_s(11,18); end;
 if (ver[14].z=0)and(ver[15].z=0)and(ver[10].z<>0)and(ver[18].z<>0) then
  begin set_s(9,15);set_s(14,19); end;
 if (ver[10].z=0)and(ver[18].z=0)and(ver[14].z<>0)and(ver[15].z<>0) then
  begin set_s(9,18);set_s(10,19); end;

 if (ver[14].z=0)and(ver[10].z=0)and(ver[15].z=0)and(ver[18].z<>0) then
  set_s(14,19);
 if (ver[10].z=0)and(ver[14].z=0)and(ver[18].z=0)and(ver[15].z<>0) then
  set_s(10,19);
 if (ver[14].z=0)and(ver[18].z=0)and(ver[15].z=0)and(ver[10].z<>0) then
  set_s(9,15);
 if (ver[10].z=0)and(ver[15].z=0)and(ver[18].z=0)and(ver[14].z<>0) then
  set_s(9,18);

 if (ver[14].z=0)and(ver[10].z=0)and(ver[15].z=0)and(ver[18].z=0) then
  set_s(14,15);



 if (ver[15].z=0)and(ver[12].z=0)and(ver[20].z<>0)and(ver[16].z<>0) then
  begin set_s(15,21);set_s(12,21); end;
 if (ver[12].z=0)and(ver[16].z=0)and(ver[15].z<>0)and(ver[20].z<>0) then
  begin set_s(19,12);set_s(19,16); end;
 if (ver[20].z=0)and(ver[16].z=0)and(ver[15].z<>0)and(ver[12].z<>0) then
  begin set_s(11,20);set_s(11,16); end;
 if (ver[15].z=0)and(ver[20].z=0)and(ver[12].z<>0)and(ver[16].z<>0) then
  begin set_s(13,15);set_s(13,20); end;
 if (ver[15].z=0)and(ver[16].z=0)and(ver[12].z<>0)and(ver[20].z<>0) then
  begin set_s(11,16);set_s(15,21); end;
 if (ver[12].z=0)and(ver[20].z=0)and(ver[15].z<>0)and(ver[16].z<>0) then
  begin set_s(11,20);set_s(12,21); end;

 if (ver[15].z=0)and(ver[12].z=0)and(ver[16].z=0)and(ver[20].z<>0) then
  set_s(15,21);
 if (ver[12].z=0)and(ver[15].z=0)and(ver[20].z=0)and(ver[16].z<>0) then
  set_s(12,21);
 if (ver[15].z=0)and(ver[20].z=0)and(ver[16].z=0)and(ver[12].z<>0) then
  set_s(11,16);
 if (ver[12].z=0)and(ver[16].z=0)and(ver[20].z=0)and(ver[15].z<>0) then
  set_s(11,20);

 if (ver[15].z=0)and(ver[12].z=0)and(ver[16].z=0)and(ver[20].z=0) then
  set_s(15,16);

 ///
 if (ver[2].z=0)and(ver[6].z<>0)and(ver[7].z<>0)and(ver[10].z<>0) then
  begin set_s(2,9); set_s(2,11); end;
 if (ver[7].z=0)and(ver[6].z<>0)and(ver[2].z<>0)and(ver[10].z<>0) then
  begin set_s(1,7); set_s(9,7); end;
 if (ver[10].z=0)and(ver[6].z<>0)and(ver[7].z<>0)and(ver[2].z<>0) then
  begin set_s(10,1); set_s(10,3); end;
 if (ver[6].z=0)and(ver[2].z<>0)and(ver[7].z<>0)and(ver[10].z<>0) then
  begin set_s(6,3); set_s(6,11); end;

 ///
 if (ver[4].z=0)and(ver[7].z<>0)and(ver[12].z<>0)and(ver[8].z<>0) then
  begin set_s(4,11); set_s(4,13); end;
 if (ver[8].z=0)and(ver[4].z<>0)and(ver[7].z<>0)and(ver[12].z<>0) then
  begin set_s(3,8); set_s(11,8); end;
 if (ver[12].z=0)and(ver[7].z<>0)and(ver[4].z<>0)and(ver[8].z<>0) then
  begin set_s(12,3); set_s(12,5); end;
 if (ver[7].z=0)and(ver[4].z<>0)and(ver[8].z<>0)and(ver[12].z<>0) then
  begin set_s(7,5); set_s(7,13); end;

 ///
 if (ver[10].z=0)and(ver[14].z<>0)and(ver[18].z<>0)and(ver[15].z<>0) then
  begin set_s(10,17); set_s(10,19); end;
 if (ver[15].z=0)and(ver[10].z<>0)and(ver[14].z<>0)and(ver[18].z<>0) then
  begin set_s(15,9); set_s(15,17); end;
 if (ver[18].z=0)and(ver[14].z<>0)and(ver[10].z<>0)and(ver[15].z<>0) then
  begin set_s(18,9); set_s(18,11); end;
 if (ver[14].z=0)and(ver[10].z<>0)and(ver[15].z<>0)and(ver[18].z<>0) then
  begin set_s(14,11); set_s(14,19); end;

 if (ver[12].z=0)and(ver[15].z<>0)and(ver[20].z<>0)and(ver[16].z<>0) then
  begin set_s(12,19); set_s(12,21); end;
 if (ver[16].z=0)and(ver[12].z<>0)and(ver[15].z<>0)and(ver[20].z<>0) then
  begin set_s(16,11); set_s(16,19); end;
 if (ver[20].z=0)and(ver[15].z<>0)and(ver[12].z<>0)and(ver[16].z<>0) then
  begin set_s(20,11); set_s(20,13); end;
 if (ver[15].z=0)and(ver[12].z<>0)and(ver[16].z<>0)and(ver[20].z<>0) then
  begin set_s(15,13); set_s(15,21); end;

 //ShowMessage(FloatToStr(ver[6].z));
 if (ver[6].z<>0)and(ver[2].z<>0)and(ver[7].z<>0)and(ver[10].z<>0) then
  set_s(1,11);
 if (ver[7].z<>0)and(ver[4].z<>0)and(ver[8].z<>0)and(ver[12].z<>0) then
  set_s(3,13);
 if (ver[14].z<>0)and(ver[10].z<>0)and(ver[15].z<>0)and(ver[18].z<>0) then
  set_s(9,19);
 if (ver[15].z<>0)and(ver[12].z<>0)and(ver[16].z<>0)and(ver[20].z<>0) then
  set_s(11,21);


 //if is_set(1,6)=False then ShowMessage('FALSE!');

 visual();
 ShowMessage('      .');

 Form1.Image1.Canvas.Pen.Color:=clGray;
 Form1.Image1.Canvas.Rectangle(0,0,601,601);
 for i:=1 to 30000 do
 begin
  k:=random(21)+1;l:=random(21)+1;
  if is_set(k,l)=True then
  begin
    Form1.Image1.Canvas.MoveTo(ver[k].xm,ver[k].ym);
    Form1.Image1.Canvas.LineTo(ver[l].xm,ver[l].ym);
  end;
 end;
 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(52,10,FloatToStr(m_now[0,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(52,23,FloatToStr(m_prj[0,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(52,36,FloatToStr(m_wor[0,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,10,FloatToStr(m_now[1,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,23,FloatToStr(m_prj[1,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,36,FloatToStr(m_wor[1,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,10,FloatToStr(m_now[2,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,23,FloatToStr(m_prj[2,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,36,FloatToStr(m_wor[2,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(15,310,FloatToStr(m_now[0,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(15,323,FloatToStr(m_prj[0,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(15,336,FloatToStr(m_wor[0,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,310,FloatToStr(m_now[1,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,323,FloatToStr(m_prj[1,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,336,FloatToStr(m_wor[1,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,310,FloatToStr(m_now[2,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,323,FloatToStr(m_prj[2,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,336,FloatToStr(m_wor[2,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(52,555,FloatToStr(m_now[0,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(52,568,FloatToStr(m_prj[0,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(52,581,FloatToStr(m_wor[0,2]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,555,FloatToStr(m_now[1,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,568,FloatToStr(m_prj[1,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,581,FloatToStr(m_wor[1,2]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,555,FloatToStr(m_now[2,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,568,FloatToStr(m_prj[2,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,581,FloatToStr(m_wor[2,2]));

 ShowMessage('   .');

 l:=0;
 for i:=1 to 21 do
  for j:=i to 21 do
   for k:=j to 21 do
   begin
    if (ver[i].z<>-10000)and(ver[j].z<>-10000)and(ver[k].z<>-10000) then
    begin
     if (is_set(i,j)=True)and(is_set(j,k)=True)and(is_set(k,i)=True) then
     begin
      l:=l+1;
      visual();
      Form1.Image1.Canvas.Pen.Color:=clLime;
      Form1.Image1.Canvas.MoveTo(ver[i].xm,ver[i].ym);
      Form1.Image1.Canvas.LineTo(ver[j].xm,ver[j].ym);
      Form1.Image1.Canvas.LineTo(ver[k].xm,ver[k].ym);
      Form1.Image1.Canvas.LineTo(ver[i].xm,ver[i].ym);
      Form1.Image1.Repaint;
      Form1.Image1.Refresh;
      Sleep(100);
      Form1.Memo1.Lines.Add('');
      Form1.Memo1.Lines.Add('   '+IntToStr(l)+':');

      Form1.Memo1.Lines.Add(' 1: X='+FloatToStr(ver[i].xr)+', Y='+
                             FloatToStr(ver[i].yr)+', h='+FloatToStr(ver[i].z));
      Form1.Memo1.Lines.Add(' 2: X='+FloatToStr(ver[j].xr)+', Y='+
                             FloatToStr(ver[j].yr)+', h='+FloatToStr(ver[j].z));
      Form1.Memo1.Lines.Add(' 3: X='+FloatToStr(ver[k].xr)+', Y='+
                             FloatToStr(ver[k].yr)+', h='+FloatToStr(ver[k].z));
      vt:=calc_v(ver[i].xr,ver[i].yr,ver[i].z,ver[j].xr,ver[j].yr,ver[j].z,ver[k].xr,ver[k].yr,ver[k].z);
      Form1.Memo1.Lines.Add(' = '+FloatToStr(Round(vt*1000)/1000));
      //ShowMessage('     '+IntToStr(l)+': '+FloatToStr(vt));
      if vt<0 then VO:=VO+vt else VP:=VP+vt;
     end;
    end;
   end;
   visual();
   Form1.Memo1.Lines.Add('');
   Form1.Memo1.Lines.Add(':');
   Form1.Memo1.Lines.Add('  : '+FloatToStr(Round(VP*1000)/1000));
   Form1.Memo1.Lines.Add('  : '+FloatToStr(Round(VO*1000)/1000));
   Form1.Memo1.Lines.Add(' : '+FloatToStr(Round((VP+VO)*1000)/1000));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Form1.Edit1.Text:='-0,009';
 Form1.Edit2.Text:='-0,002';
 Form1.Edit3.Text:='20';
 Form1.Edit4.Text:='72';
 Form1.Edit5.Text:='71,777';
 Form1.Edit6.Text:='71,810';
 Form1.Edit7.Text:='71,890';
 Form1.Edit8.Text:='71,910';
 Form1.Edit9.Text:='71,757';
 Form1.Edit10.Text:='71,595';
 Form1.Edit11.Text:='72,141';
 Form1.Edit12.Text:='72,446';
 Form1.Edit13.Text:='71,966';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 VO:=0;
 VP:=0;
 for i:=1 to 21 do for j:=1 to 21 do diset_s(i,j);
 for i:=1 to 21 do ver[i].z:=-10000;
 Form1.Memo1.Text:='';
 Form1.Edit1.Text:='';
 Form1.Edit2.Text:='';
 Form1.Edit3.Text:='';
 Form1.Edit4.Text:='';
 Form1.Edit5.Text:='';
 Form1.Edit6.Text:='';
 Form1.Edit7.Text:='';
 Form1.Edit8.Text:='';
 Form1.Edit9.Text:='';
 Form1.Edit10.Text:='';
 Form1.Edit11.Text:='';
 Form1.Edit12.Text:='';
 Form1.Edit13.Text:='';
 Form1.Image1.Canvas.Pen.Color:=clBlack;
 Form1.Image1.Canvas.Rectangle(0,0,601,601);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
 xx1,yy1,xx2,yy2: Integer;
begin
 Form1.Image1.Canvas.Pen.Color:=clBlack;
 Form1.Image1.Canvas.Rectangle(0,0,601,601);

 Form1.Image1.Canvas.Pen.Color:=clGreen;
 Form1.Image1.Canvas.Rectangle(50,50,550,550);
 Form1.Image1.Canvas.MoveTo(300,50);
 Form1.Image1.Canvas.LineTo(300,550);
 Form1.Image1.Canvas.MoveTo(50,300);
 Form1.Image1.Canvas.LineTo(550,300);

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(52,10,FloatToStr(m_now[0,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(52,23,FloatToStr(m_prj[0,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(52,36,FloatToStr(m_wor[0,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,10,FloatToStr(m_now[1,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,23,FloatToStr(m_prj[1,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,36,FloatToStr(m_wor[1,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,10,FloatToStr(m_now[2,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,23,FloatToStr(m_prj[2,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,36,FloatToStr(m_wor[2,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(15,310,FloatToStr(m_now[0,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(15,323,FloatToStr(m_prj[0,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(15,336,FloatToStr(m_wor[0,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,310,FloatToStr(m_now[1,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,323,FloatToStr(m_prj[1,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,336,FloatToStr(m_wor[1,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,310,FloatToStr(m_now[2,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,323,FloatToStr(m_prj[2,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,336,FloatToStr(m_wor[2,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(52,555,FloatToStr(m_now[0,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(52,568,FloatToStr(m_prj[0,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(52,581,FloatToStr(m_wor[0,2]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,555,FloatToStr(m_now[1,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,568,FloatToStr(m_prj[1,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,581,FloatToStr(m_wor[1,2]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,555,FloatToStr(m_now[2,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,568,FloatToStr(m_prj[2,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,581,FloatToStr(m_wor[2,2]));

 Form1.Image1.Canvas.Pen.Color:=clRed;


 for i:=1 to 12 do
 begin
 if (nul_p[i].x<>-10000) then
  Form1.Image1.Canvas.Rectangle(npg[i].x-2,npg[i].y-2,npg[i].x+2,npg[i].y+2);
 end;

 for i:=1 to 24 do
 begin
  if (nul_p[lt[i].x].x<>-10000)and(nul_p[lt[i].y].x<>-10000) then
  begin
   Form1.Image1.Canvas.MoveTo(npg[lt[i].x].x,npg[lt[i].x].y);
   Form1.Image1.Canvas.LineTo(npg[lt[i].y].x,npg[lt[i].y].y);
   //Form1.Repaint;

  end;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 VO:=0;
 VP:=0;
 Randomize;
 for i:=1 to 21 do ver[i].z:=-10000;
 Form1.Image1.Canvas.Pen.Color:=0;
 Form1.Image1.Canvas.Rectangle(0,0,601,601);
 lt[1].x:=1;
 lt[1].y:=9;
 lt[2].x:=9;
 lt[2].y:=3;
 lt[3].x:=3;
 lt[3].y:=7;
 lt[4].x:=7;
 lt[4].y:=1;
 lt[5].x:=1;
 lt[5].y:=3;
 lt[6].x:=7;
 lt[6].y:=9;

 lt[7].x:=2;
 lt[7].y:=11;
 lt[8].x:=11;
 lt[8].y:=4;
 lt[9].x:=4;
 lt[9].y:=9;
 lt[10].x:=9;
 lt[10].y:=2;
 lt[11].x:=2;
 lt[11].y:=4;
 lt[12].x:=9;
 lt[12].y:=11;

 lt[13].x:=4;
 lt[13].y:=12;
 lt[14].x:=12;
 lt[14].y:=6;
 lt[15].x:=6;
 lt[15].y:=10;
 lt[16].x:=10;
 lt[16].y:=4;
 lt[17].x:=4;
 lt[17].y:=6;
 lt[18].x:=10;
 lt[18].y:=12;

 lt[19].x:=3;
 lt[19].y:=10;
 lt[20].x:=10;
 lt[20].y:=5;
 lt[21].x:=5;
 lt[21].y:=8;
 lt[22].x:=8;
 lt[22].y:=3;
 lt[23].x:=3;
 lt[23].y:=5;
 lt[24].x:=8;
 lt[24].y:=10;
end;

function is_one(x1: Real; x2: Real): Boolean;
//  True,     .
begin
 is_one:=False;
 if (x1>0) and (x2>0) then is_one:=True;
 if (x1<0) and (x2<0) then is_one:=True;
end;

function distance(x1: Real; y1: Real; x2: Real; y2: Real): Real;
//       
begin
 distance:=sqrt(sqr(x1-x2)+sqr(y1-y2));
end;

function calc_v(x1: Real; y1: Real; z1: Real; x2: Real; y2: Real; z2: Real; x3: Real; y3: Real; z3: Real): Real;
//   
var
 s: Real;
begin
 s:=sqrt(sqr((x1-x2)*(y3-y1)-(x3-x1)*(y2-y1)))/2;
 //s:=distance(x1,y1,x2,y2)*distance(x2,y2,x3,(abs(y3)-abs(y2))/2);
 //ShowMessage('!!!S = '+FloatToStr(s));
 calc_v:=(z1+z2+z3)*s/3;
end;

procedure set_s(v1: Integer; v2: Integer);
begin
 pl[v1,v2]:=1;
 pl[v2,v1]:=1;
end;

procedure diset_s(v1: Integer; v2: Integer);
begin
 pl[v1,v2]:=0;
 pl[v2,v1]:=0;
end;

function is_set(v1: Integer; v2: Integer): Boolean;
begin
 if pl[v1,v2]=1 then is_set:=True else is_set:=False;
end;

procedure cr_st_one();
var
 i,j,k,f: Integer;
begin
 for i:=1 to 21 do ver[i].z:=-10000;
 set_s(1,3);
 set_s(1,9);
 set_s(3,11);
 set_s(3,5);
 set_s(5,13);
 set_s(9,11);
 set_s(9,17);
 set_s(13,11);
 set_s(13,21);
 set_s(17,19);
 set_s(19,11);
 set_s(19,21);
 k:=0;
 for i:=0 to 2 do
 begin
  for j:=0 to 2 do
  begin
   f:=0;
   if (i=0)and(j=0) then begin k:=1; f:=1; end;
   if (i=1)and(j=0) then begin k:=3; f:=1; end;
   if (i=2)and(j=0) then begin k:=5; f:=1; end;
   if (i=0)and(j=1) then begin k:=9; f:=1; end;
   if (i=1)and(j=1) then begin k:=11; f:=1; end;
   if (i=2)and(j=1) then begin k:=13; f:=1; end;
   if (i=0)and(j=2) then begin k:=17; f:=1; end;
   if (i=1)and(j=2) then begin k:=19; f:=1; end;
   if (i=2)and(j=2) then begin k:=21; f:=1; end;
   if (f=1) then
   begin
    ver[k].xm:=50+i*250;
    ver[k].ym:=50+j*250;
    ver[k].z:=m_wor[i,j];
    ver[k].xr:=j*dist;
    ver[k].yr:=i*dist;
   end;
  end;
 end;
end;

procedure cr_st_two();
begin
 if (nul_p[1].x<>-10000) then
 begin
  diset_s(1,3);
  set_s(1,2);
  set_s(2,3);
  ver[2].xm:=npg[1].x;
  ver[2].ym:=npg[1].y;
  ver[2].z:=0;
  ver[2].yr:=nul_p[1].x;
  ver[2].xr:=nul_p[1].y;
 end;

 if (nul_p[2].x<>-10000) then
 begin
  diset_s(3,5);
  set_s(3,4);
  set_s(4,5);
  ver[4].xm:=npg[2].x;
  ver[4].ym:=npg[2].y;
  ver[4].z:=0;
  ver[4].yr:=nul_p[2].x;
  ver[4].xr:=nul_p[2].y;
 end;

 if (nul_p[3].x<>-10000) then
 begin
  diset_s(9,11);
  set_s(9,10);
  set_s(10,11);
  ver[10].xm:=npg[3].x;
  ver[10].ym:=npg[3].y;
  ver[10].z:=0;
  ver[10].yr:=nul_p[3].x;
  ver[10].xr:=nul_p[3].y;
 end;

 if (nul_p[4].x<>-10000) then
 begin
  diset_s(11,13);
  set_s(11,12);
  set_s(12,13);
  ver[12].xm:=npg[4].x;
  ver[12].ym:=npg[4].y;
  ver[12].z:=0;
  ver[12].yr:=nul_p[4].x;
  ver[12].xr:=nul_p[4].y;
 end;

 if (nul_p[5].x<>-10000) then
 begin
  diset_s(17,19);
  set_s(17,18);
  set_s(18,19);
  ver[18].xm:=npg[5].x;
  ver[18].ym:=npg[5].y;
  ver[18].z:=0;
  ver[18].yr:=nul_p[5].x;
  ver[18].xr:=nul_p[5].y;
 end;

 if (nul_p[6].x<>-10000) then
 begin
  diset_s(19,21);
  set_s(19,20);
  set_s(20,21);
  ver[20].xm:=npg[6].x;
  ver[20].ym:=npg[6].y;
  ver[20].z:=0;
  ver[20].yr:=nul_p[6].x;
  ver[20].xr:=nul_p[6].y;
 end;

 if (nul_p[7].x<>-10000) then
 begin
  diset_s(1,9);
  set_s(1,6);
  set_s(6,9);
  ver[6].xm:=npg[7].x;
  ver[6].ym:=npg[7].y;
  ver[6].z:=0;
  ver[6].yr:=nul_p[7].x;
  ver[6].xr:=nul_p[7].y;
 end;

 if (nul_p[8].x<>-10000) then
 begin
  diset_s(9,17);
  set_s(9,14);
  set_s(14,17);
  ver[14].xm:=npg[8].x;
  ver[14].ym:=npg[8].y;
  ver[14].z:=0;
  ver[14].yr:=nul_p[8].x;
  ver[14].xr:=nul_p[8].y;
 end;

 if (nul_p[9].x<>-10000) then
 begin
  diset_s(3,11);
  set_s(3,7);
  set_s(7,11);
  ver[7].xm:=npg[9].x;
  ver[7].ym:=npg[9].y;
  ver[7].z:=0;
  ver[7].yr:=nul_p[9].x;
  ver[7].xr:=nul_p[9].y;
 end;

 if (nul_p[10].x<>-10000) then
 begin
  diset_s(11,19);
  set_s(11,15);
  set_s(15,19);
  ver[15].xm:=npg[10].x;
  ver[15].ym:=npg[10].y;
  ver[15].z:=0;
  ver[15].yr:=nul_p[10].x;
  ver[15].xr:=nul_p[10].y;
 end;

 if (nul_p[11].x<>-10000) then
 begin
  diset_s(5,13);
  set_s(5,8);
  set_s(8,13);
  ver[8].xm:=npg[11].x;
  ver[8].ym:=npg[11].y;
  ver[8].z:=0;
  ver[8].yr:=nul_p[11].x;
  ver[8].xr:=nul_p[11].y;
 end;

 if (nul_p[12].x<>-10000) then
 begin
  diset_s(13,21);
  set_s(13,16);
  set_s(16,21);
  ver[16].xm:=npg[12].x;
  ver[16].ym:=npg[12].y;
  ver[16].z:=0;
  ver[16].yr:=nul_p[12].x;
  ver[16].xr:=nul_p[12].y;
 end;

 if (ver[2].z<>-10000)and(ver[7].z<>-10000)then set_s(2,7);
 if (ver[7].z<>-10000)and(ver[10].z<>-10000)then set_s(7,10);
 if (ver[10].z<>-10000)and(ver[6].z<>-10000)then set_s(10,6);
 if (ver[6].z<>-10000)and(ver[2].z<>-10000)then set_s(6,2);
 if (ver[2].z<>-10000)and(ver[10].z<>-10000)then set_s(2,10);
 if (ver[6].z<>-10000)and(ver[7].z<>-10000)then set_s(6,7);

 if (ver[4].z<>-10000)and(ver[8].z<>-10000)then set_s(4,8);
 if (ver[8].z<>-10000)and(ver[12].z<>-10000)then set_s(8,12);
 if (ver[12].z<>-10000)and(ver[7].z<>-10000)then set_s(12,7);
 if (ver[7].z<>-10000)and(ver[4].z<>-10000)then set_s(7,4);
 if (ver[4].z<>-10000)and(ver[12].z<>-10000)then set_s(4,12);
 if (ver[7].z<>-10000)and(ver[8].z<>-10000)then set_s(7,8);

 if (ver[10].z<>-10000)and(ver[15].z<>-10000)then set_s(10,15);
 if (ver[15].z<>-10000)and(ver[18].z<>-10000)then set_s(15,18);
 if (ver[18].z<>-10000)and(ver[14].z<>-10000)then set_s(18,14);
 if (ver[14].z<>-10000)and(ver[10].z<>-10000)then set_s(14,10);
 if (ver[10].z<>-10000)and(ver[18].z<>-10000)then set_s(10,18);
 if (ver[14].z<>-10000)and(ver[15].z<>-10000)then set_s(14,15);

 if (ver[12].z<>-10000)and(ver[16].z<>-10000)then set_s(12,16);
 if (ver[16].z<>-10000)and(ver[20].z<>-10000)then set_s(16,20);
 if (ver[20].z<>-10000)and(ver[15].z<>-10000)then set_s(20,15);
 if (ver[15].z<>-10000)and(ver[12].z<>-10000)then set_s(15,12);
 if (ver[12].z<>-10000)and(ver[20].z<>-10000)then set_s(12,20);
 if (ver[15].z<>-10000)and(ver[16].z<>-10000)then set_s(15,16);

end;

procedure visual();
var
 i,j,k,l: Integer;
begin
 Form1.Image1.Canvas.Pen.Color:=clBlack;
 Form1.Image1.Canvas.Rectangle(0,0,601,601);

 Form1.Image1.Canvas.Pen.Color:=clGreen;
 Form1.Image1.Canvas.Rectangle(50,50,550,550);
 Form1.Image1.Canvas.MoveTo(300,50);
 Form1.Image1.Canvas.LineTo(300,550);
 Form1.Image1.Canvas.MoveTo(50,300);
 Form1.Image1.Canvas.LineTo(550,300);

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(52,10,FloatToStr(m_now[0,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(52,23,FloatToStr(m_prj[0,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(52,36,FloatToStr(m_wor[0,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,10,FloatToStr(m_now[1,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,23,FloatToStr(m_prj[1,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,36,FloatToStr(m_wor[1,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,10,FloatToStr(m_now[2,0]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,23,FloatToStr(m_prj[2,0]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,36,FloatToStr(m_wor[2,0]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(15,310,FloatToStr(m_now[0,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(15,323,FloatToStr(m_prj[0,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(15,336,FloatToStr(m_wor[0,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,310,FloatToStr(m_now[1,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,323,FloatToStr(m_prj[1,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,336,FloatToStr(m_wor[1,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,310,FloatToStr(m_now[2,1]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,323,FloatToStr(m_prj[2,1]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,336,FloatToStr(m_wor[2,1]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(52,555,FloatToStr(m_now[0,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(52,568,FloatToStr(m_prj[0,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(52,581,FloatToStr(m_wor[0,2]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(302,555,FloatToStr(m_now[1,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(302,568,FloatToStr(m_prj[1,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(302,581,FloatToStr(m_wor[1,2]));

 Form1.Image1.Canvas.Font.Color:=clGreen;
 Form1.Image1.Canvas.TextOut(552,555,FloatToStr(m_now[2,2]));
 Form1.Image1.Canvas.Font.Color:=clBlue;
 Form1.Image1.Canvas.TextOut(552,568,FloatToStr(m_prj[2,2]));
 Form1.Image1.Canvas.Font.Color:=clBlack;
 Form1.Image1.Canvas.TextOut(552,581,FloatToStr(m_wor[2,2]));

 Form1.Image1.Canvas.Pen.Color:=clRed;


 for i:=1 to 12 do
 begin
 if (nul_p[i].x<>-10000) then
  Form1.Image1.Canvas.Rectangle(npg[i].x-2,npg[i].y-2,npg[i].x+2,npg[i].y+2);
 end;

 for i:=1 to 24 do
 begin
  if (nul_p[lt[i].x].x<>-10000)and(nul_p[lt[i].y].x<>-10000) then
  begin
   Form1.Image1.Canvas.MoveTo(npg[lt[i].x].x,npg[lt[i].x].y);
   Form1.Image1.Canvas.LineTo(npg[lt[i].y].x,npg[lt[i].y].y);
   //Form1.Repaint;

  end;
 end; 
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
 Form2.Visible:=True;
end;

end.
